#include "bsp_usart.h"
#include "parameter.h"
USERSTR UartStr;
struct WIRELESS_INIT wireless_init = WIRELESS_INIT_DEFAULT;
static uint8_t WirelessModuleSet[10] = {0xC1,0xC1,0xC1,0xC0,0x64,0x36,0x25,0x4C,0xCC};
u8 TestData[8] = {0x00,0xF8,0xF8,0x01,0x02,0x03,0x04,0x05};
uint8_t UartRecLen = 0;
char UartRecBuff[100] = {0};
uint8_t UartTimeOut = 0;
int BaudCnt = 3;
uint32_t BaudRateUser[10] = {4800,9600,14400,19200,38400,56000,57600,115200};
void UartRecDeal(void)
{
    
    UartTimeOut = 2;
    UartRecBuff[UartRecLen++] = USART_ReceiveData8(USART1);
    USART_ClearITPendingBit(USART1,USART_IT_RXNE);
    if(UartRecLen>=100)UartRecLen = 0;
}

void UartRecClr(void)
{
    memset(UartRecBuff,0,100*sizeof(uint8_t));
    UartRecLen = 0;
}
int fputc(int ch, FILE *f)//STM8S105,printfض 
{ 
  while (!(USART1->SR&0x80)); 
  USART1->DR=ch;
  return ch; 
} 
void HostPCSend(void)
{
    //uint32_t LoraChannel = 0;
    char temp[50] = {0},temp2[10] = {0};
    if(UartRecLen&&(UartTimeOut==0)&&(TxModel))
    {
        GPIO_ToggleBits(LED_GPIO,LED2_PIN);
        if((memcmp(UartRecBuff,"AT+TEST",sizeof("AT+TEST")))==NULL)//test
        {
          printf("OK!\r\n");
        }
        else if((strstr(UartRecBuff,"AT+FRECFG:"))!=NULL)//fre cfg
        {
          HexStrToByte(UartRecBuff+10,SystemPara.PcID,8);
          FixedParaChange(TRUE);
          printf("AT+FRECFG:OK!\r\n");
        }
        else if(memcmp(UartRecBuff,"AT+FREQUE",sizeof("AT+FREQUE"))==NULL)
        {
          ByteToHexStr(SystemPara.PcID,temp2,4);
          sprintf(temp,"AT+FRECFG%s:OK!\r\n",temp2);
          printf("%s",temp);
        }
        else if(memcmp(UartRecBuff,"AT+RST",sizeof("AT+RST"))==NULL)//soft rst
        {
          asm("LDW X,  SP ");
          asm("LD  A,  $FF");
          asm("LD  XL, A  ");
          asm("LDW SP, X  ");
          asm("JPF $8000");
        }
        else if(memcmp(UartRecBuff,"AT+BAUDRATE?",sizeof("AT+BAUDRATE?"))==NULL)//BaudRate
        {
          printf("AT+BAUDRATE=%d\r\n",BaudCnt);
        }
        else if((strstr(UartRecBuff,"AT+BAUDRATE="))!=NULL)//BaudRate cfg
        {
          if(((UartRecBuff[12] - 0x30)<0)||((UartRecBuff[12] - 0x30)>7))
          {
            printf("BaudCfgError!\r\n");
          }
          else
          {
            BaudCnt = UartRecBuff[12] - 0x30;
            printf("AT+BAUDCFG:OK!\r\n");
            while((USART1->SR & (1<<6))==0);
            USART_Cmd(USART1,DISABLE);
            USART_Init(USART1,BaudRateUser[BaudCnt],USART_WordLength_8b,USART_StopBits_1,USART_Parity_No,(USART_Mode_TypeDef)(USART_Mode_Tx |USART_Mode_Rx ));
            USART_Cmd(USART1,ENABLE);
            
          }
        }
        else if(memcmp(UartRecBuff,"AT+UPDATE",sizeof("AT+UPDATE"))==NULL)//UpDate
        {
          printf("UpDate Start...\r\n");
          while((USART1->SR & (1<<6))==0);
          asm("LDW X,  SP ");
          asm("LD  A,  $FF");
          asm("LD  XL, A  ");
          asm("LDW SP, X  ");
          asm("JPF $6000");
        }
        else
        {
          if(UartRecLen<4)
          {
              memset(UartRecBuff,0,100*sizeof(uint8_t));
              UartRecLen = 0;
              printf("DataError!\r\n");
              return;
          }
          SX78Str.SX7xTxFlag = TRUE;
          SX78Str.SX7xCmd = CmdTX;  
          //SystemPara.LockID[2] = UartRecBuff[2];
          memcpy(SystemPara.LockID,UartRecBuff,3*sizeof(uint8_t));
//          if(SystemPara.LockID[2]>83)SystemPara.LockID[2] = 23;
//          LoraChannel = SystemPara.LockID[2] + 410;
//          LoraChannel *= 1024*16;
//          LoraPara.TxChannel[0] = (uint8_t)(LoraChannel);
//          LoraPara.TxChannel[1] = (uint8_t)(LoraChannel>>8);
//          LoraChannel = LoraChannel>>8;
//          LoraPara.TxChannel[2] = (uint8_t)(LoraChannel>>8);   
          LoraParaRead();
          memcpy(SX78Str.SX7xTxStr,UartRecBuff,SX78Str.SX7xTxlen = (UartRecLen)*sizeof(uint8_t));
        }
        UartRecClr();
    }
}
void bsp_usart_init(void)
{
      CLK_PeripheralClockConfig(CLK_Peripheral_USART1,ENABLE);
      GPIO_ExternalPullUpConfig(GPIOC, GPIO_Pin_3, ENABLE);
      GPIO_ExternalPullUpConfig(GPIOC, GPIO_Pin_2, ENABLE);
      USART_Init(USART1,19200,USART_WordLength_8b,USART_StopBits_1,USART_Parity_No,(USART_Mode_TypeDef)(USART_Mode_Tx |USART_Mode_Rx ));
      USART_ITConfig(USART1,USART_IT_RXNE,ENABLE);
      USART_Cmd(USART1,ENABLE);
}

void UartTest(void)
{
    if(!wireless_init.InitFlag)
    {
        WirelessInit(&wireless_init,WirelessModuleSet,6);
    }
    else
    {
        if(UartStr.Cnt>0)return;
        UartStr.Cnt = 1000;
        UsartPrint(TestData,8);
    }
/*
    if(!UARTTEST)return;
    if(UartStr.Cnt>0)return;
    UartStr.Cnt = 4000;
    UsartPrint(TestData,5);
*/
}

void UsartPrint(uint8_t *data,uint32_t len)
{
      uint32_t i = 0;
      while((USART1->SR&0x80)==0);
      for(i=0;i<len;i++)
      {
          USART1->DR = *(data++);
          while((USART1->SR&0x40)==0);
      }
      asm("NOP");
}
static void WirelessInit(struct WIRELESS_INIT *WirelessInitCp,uint8_t *wireless,uint8_t num)
{
    if(WirelessInitCp->InitFlag)return;
    if(WirelessInitCp->InitDelay)return;
    if(UartTimeOut)return;
    static int cmd_count = 0,cmd_state=0;
    switch(cmd_state)
    {
        case init_start:
        {
            WiRELESSINIT;
            ConfigMode3;
            //nrf_delay_ms(10);
            cmd_count = 0;
            cmd_state = winit_cmd_send;
            UsartPrint(wireless,3);
            cmd_state = init_delay;
            WirelessInitCp->SendDelay = 50;
            break;
        }
        case init_cmd_send:
        {
            UsartPrint(wireless+3,num);
            cmd_state = init_delay;
            WirelessInitCp->SendDelay = 50;
            break;
        }
        case init_delay:
        {
            if(WirelessInitCp->SendDelay)break;
            cmd_state = init_ing;
            break;
        }
        case init_ing:
        {
            if(strstr((char *)UartRecBuff,(char *)(WirelessModuleSet+3))!=NULL)
            {
                memset((char *)UartRecBuff,0,25*sizeof(char));
                UartRecLen = 0;
                cmd_state = init_ok;
                break;
            }
            else
            {
                if(cmd_count>10)
                {
                    cmd_state = init_error;
                    break;
                }
                else
                {
                    cmd_count++;
                    cmd_state = init_cmd_send;
                    break;
                }
            }
        }
        case init_ok:
        {
            ConfigMode2;
            //nrf_delay_ms(10);
            //beep_start(1,2,2);
            WirelessInitCp->InitFlag = TRUE;
            cmd_state = winit_start;
            cmd_count = 0;
            USART_Init(USART1,19200,USART_WordLength_8b,USART_StopBits_1,USART_Parity_No,(USART_Mode_TypeDef)(USART_Mode_Tx | USART_Mode_Rx ));
            break;
        }
        case init_error:
        {
            WirelessInitCp->InitFlag = FALSE;
            WirelessInitCp->InitDelay = 1000;
            cmd_state = winit_start;
            cmd_count = 0;
        }
        default:break;
    }
}

