/**
  ******************************************************************************
  * @file    	i2c.c
  * @author  MCD Application Team
  * @version V1.0.0
  * @date    24-11-2014
  * @brief   
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; COPYRIGHT 2011 STMicroelectronics</center></h2>
  ******************************************************************************  
  */ 
#include "stm8l15x.h"
#include "i2c.h"

 /*I2C豸*/
uint8_t SlaveAddress;
extern u8 BUF[8]; 

static void I2C_delay(void);
//static void delay5ms(void);
static bool I2C_Start(void);
static uint8_t I2C_RadeByte(void);
static void I2C_SendByte(uint8_t SendByte);
static bool I2C_WaitAck(void);
static void I2C_NoAck(void);
//static void I2C_Ack(void);
static void I2C_Stop(void);


/*I2C˿ڳʼ---------------------------------------*/
void I2C_GPIO_Init(void)
{
    GPIO_Init(I2C_GPIO, I2C_SCL_PIN, GPIO_Mode_Out_OD_Low_Fast);
    GPIO_Init(I2C_GPIO, I2C_SDA_PIN, GPIO_Mode_Out_OD_Low_Fast);	
}

/*I2Cʱ-----------------------------------------*/
void I2C_delay(void)//5us
{
		
  // uint8_t i=30; //Żٶ	͵5д
  // while(i) 
  // { 
  //   i--; 
  // }  
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop();
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop();
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop();
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop(); 
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop(); 
    nop();nop(); nop();nop(); nop();nop(); nop();nop(); nop();nop(); 

    
}


/*I2C-------------------------------------------*/
bool I2C_Start(void)
{
#if 1   
        SDA_H;
	SCL_H;
	I2C_delay();
	if(!SDA_read)return FALSE;	//SDAΪ͵ƽæ,˳
	SDA_L;
	I2C_delay();
	if(SDA_read) return FALSE;	//SDAΪߵƽ߳,˳
	SDA_L;
	I2C_delay();
	return TRUE;
#else
    SDA_H;                    //
    SCL_H;                    //ʱ
    I2C_delay();                 //ʱ
    SDA_L;                    //½
    I2C_delay();                 //ʱ
    SCL_L;
    return TRUE;
#endif
}

/*I2Cֹͣ-------------------------------------------*/
void I2C_Stop(void)
{
#if 1
        SCL_L;
	I2C_delay();
	SDA_L;
	I2C_delay();
	SCL_H;
	I2C_delay();
	SDA_H;
	I2C_delay();
#else
    SDA_L;                    //
    SCL_H;                    //ʱ
    I2C_delay();                 //ʱ
    SDA_H;                    //
    I2C_delay(); 
#endif
} 

/*I2CACK------------------------------------------*/
/*void I2C_Ack(void)
{	
	SCL_L;
	I2C_delay();
	SDA_L;
	I2C_delay();
	SCL_H;
	I2C_delay();
	SCL_L;
	I2C_delay();
}   


*/
void I2C_Ack(u8 ack)
{
    if(ack==1)
        SDA_H;
    else
        SDA_L;
    SCL_H;                    //ʱ
    I2C_delay();                 //ʱ
    SCL_L;                    //ʱ
    I2C_delay();                 //ʱ
}
/*I2CNoACK----------------------------------------*/
void I2C_NoAck(void)
{	
	SCL_L;
	I2C_delay();
	SDA_H;
	I2C_delay();
	SCL_H;
	I2C_delay();
	SCL_L;
	I2C_delay();
} 

/*I2CȴACK----------------------------------------*/
bool I2C_WaitAck(void) 	 //Ϊ:=1ACK,=0ACK
{
#if 1
        SCL_L;
	I2C_delay();
	SDA_H;			
	I2C_delay();
	SCL_H;
	I2C_delay();
	if(SDA_read)
	{
            SCL_L;
            I2C_delay();
            return FALSE;
	}
	SCL_L;
	I2C_delay();
	return TRUE;
#else
    SCL_H;                    //ʱ
    I2C_delay();                //ʱ
    if(SDA_read)
    {
        SCL_L;
        I2C_delay();
        return FALSE;
    }                   //λ־ Ӧź
    else
    {
        SCL_L;
        I2C_delay();
        return TRUE;
    }
#endif
}

/*I2Cһu8ݺ---------------------------------*/
void I2C_SendByte(uint8_t SendByte) //ݴӸλλ//
{
#if 1
  uint8_t i = 8;
    while(i--)
    {
        SCL_L;
        I2C_delay();
        if(SendByte&0x80)
            SDA_H;  
        else 
            SDA_L;   
       // I2C_delay();
        SCL_H;
        I2C_delay(); 
        SendByte<<=1;
    }
    SCL_L;
#else
    u8 i;

    for (i=0; i<8; i++)         //8λ
    {
        //SendByte <<= 1;              //Ƴݵλ
        if(SendByte&0x80)
            SDA_H;  
        else 
            SDA_L;                //ݿ
        SendByte <<= 1;
        SCL_H;                //ʱ
        I2C_delay();             //ʱ
        SCL_L;                //ʱ
        I2C_delay();             //ʱ
    }
    I2C_WaitAck();
#endif
}  

/*I2Cȡһu8ݺ---------------------------------*/
uint8_t I2C_RadeByte(void)  //ݴӸλλ//
{ 
#if 1
    uint8_t i = 8;
    uint8_t ReceiveByte = 0;

    SDA_H;				
    while(i--)
    {
        ReceiveByte<<=1;      
        SCL_L;
        I2C_delay();
        SCL_H;
        I2C_delay();	
        if(SDA_read)
        {
            ReceiveByte|=0x01;
        }
    }
    SCL_L;
    return ReceiveByte;
#else
    u8 i;
    u8 dat = 0;

    SDA_H;                    //ʹڲ,׼ȡ,
    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;
        SCL_H;                //ʱ
        I2C_delay();             //ʱ
        if(SDA_read)
        {
            dat |= 1;             //
        }
        else
        {
            dat |= 0;
        }              
        SCL_L;                //ʱ
        I2C_delay();             //ʱ
    }
    return dat;
#endif
} 
         
/*I2Cָ豸ַָдu8-----------------------*/
void Single_WriteI2C(uint8_t REG_Address,uint8_t REG_data)//ֽд
{
	if(!I2C_Start())return;
	I2C_SendByte(SlaveAddress);   //豸ַ+дź
	if(!I2C_WaitAck()){I2C_Stop(); return;}
	I2C_SendByte(REG_Address );   //õʼַ      
	I2C_WaitAck();    
	I2C_SendByte(REG_data);
	I2C_WaitAck();   
	I2C_Stop(); 
	//DelayMs(5); //qqqqqqqq
        bsp_DelayMS(5);
}

/*I2Cָ豸ַָu8-----------------------*/
uint8_t Single_ReadI2C(uint8_t REG_Address)//ȡֽ
{   
#if 1
  uint8_t REG_data;     	
    if(!I2C_Start())
        return FALSE;
    I2C_SendByte(SlaveAddress); //øʼַ+ַ 
    if(!I2C_WaitAck())
    {
        I2C_Stop();
        return FALSE;
    }
    I2C_SendByte((u8) REG_Address);   //õʼַ      
    I2C_WaitAck();
    I2C_Start();
    I2C_SendByte(SlaveAddress+1);
    I2C_WaitAck();
    REG_data= I2C_RadeByte();
    I2C_NoAck();
    I2C_Stop();
    return REG_data;
#else
	u8 REG_data;
	I2C_Start();                          //ʼź
	I2C_SendByte(SlaveAddress);           //豸ַ+дź
	I2C_SendByte(REG_Address);            //ʹ洢Ԫַ0ʼ	
	I2C_Start();                          //ʼź
	I2C_SendByte(SlaveAddress+1);         //豸ַ+ź
	REG_data=I2C_RadeByte();              //Ĵ
	I2C_Ack(1);   
	I2C_Stop();                           //ֹͣź
  return REG_data; 
#endif
}


//******************************************************
//QMC5883ڲǶݣַΧ0x00~0x05
//******************************************************
void Multiple_Read_QMC5883(void)
{   
    u8 i;
    I2C_Start();                          //ʼź
    I2C_SendByte(SlaveAddress);          //豸ַ+дź
    I2C_WaitAck();
    I2C_SendByte(0x00);                   //ʹ洢Ԫַ0x00ʼ
    I2C_WaitAck();
    I2C_Start();                          //ʼź
    I2C_SendByte(SlaveAddress+1);        //豸ַ+ź
    I2C_WaitAck();
    for (i=0; i<6; i++)                      //ȡ6ַݣ洢BUF
    {
        BUF[i+1] = I2C_RadeByte();          //BUF[0]洢
        if (i == 5)
        {
           I2C_Ack(1);                //һҪطӦNOACK
        }
        else
        {
          I2C_Ack(0);                 //ӦACK
        }
   }
    I2C_Stop();                           //ֹͣź
   // DelayMs(5); //qqqqqq
    bsp_DelayMS(5);
}
u8 i2ctest(void)
{ 
    return Single_ReadI2C(0x09);
}

/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/





